import { Observable } from 'rxjs';
import { Options } from './../options';
import { WchToolsOptions } from './../utils/wchtools';
import { AbstractCommand } from './abstract.command';
import { Command } from './command';
/**
 * Remove arguments that we interpreted
 *
 * @param aArgs   args
 */
declare function _fixArguments(aArgs: string[]): string[];
export declare abstract class AbstractWchToolsCommand extends AbstractCommand implements Command {
    private aWchToolsOptions;
    private _wchToolsOpts;
    constructor(aWchToolsOptions: Options);
    protected getWchToolsOptions(): Observable<WchToolsOptions>;
    protected executeWchTools(aArgs: string[]): Observable<string>;
}
export { _fixArguments as wchtoolsFixArguments };
