"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var graceful_fs_1 = require("graceful-fs");
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var file_utils_1 = require("../utils/file.utils");
var constants_1 = require("./../constants");
var rx_walk_1 = require("./../utils/rx.walk");
var abstract_command_1 = require("./abstract.command");
var EXTENSIONS = ['.ts', '.css'];
var COPYRIGHT = '/* Copyright IBM Corp. 2017 */\n';
function _addCopyright(aFile) {
    // new observable
    return rxjs_1.Observable.create(function (observer) {
        // load the file
        graceful_fs_1.readFile(aFile.absPath, 'utf-8', function (errRead, data) {
            if (errRead) {
                observer.error(errRead);
            }
            else 
            // test if we need a copyright
            if (data.indexOf(COPYRIGHT) !== 0) {
                // add the copyright
                var newData = COPYRIGHT + data;
                graceful_fs_1.writeFile(aFile.absPath, newData, function (errWrite) {
                    if (errWrite) {
                        observer.error(errWrite);
                    }
                    else {
                        observer.next(aFile);
                        observer.complete();
                    }
                });
            }
            else {
                observer.complete();
            }
        });
    });
}
function _filterExtension(aFile) {
    // decode the file type
    var ext = path_1.extname(aFile.absPath);
    // check
    return EXTENSIONS.indexOf(ext) >= 0;
}
var AddCopyrightCommand = /** @class */ (function (_super) {
    __extends(AddCopyrightCommand, _super);
    function AddCopyrightCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    AddCopyrightCommand.prototype.process = function () {
        var opt = this.options;
        // load the compiler options
        var rootDir = file_utils_1.firstOf(opt.src) || '.';
        // iterate over all eligible files
        return rx_walk_1.walkFiles(rootDir).pipe(operators_1.filter(_filterExtension), operators_1.mergeMap(_addCopyright), operators_1.map(function (file) { return file.absPath; }));
    };
    AddCopyrightCommand.TYPE = constants_1.TYPE_COPYRIGHT;
    AddCopyrightCommand.COMMAND = constants_1.CMD_ADD;
    return AddCopyrightCommand;
}(abstract_command_1.AbstractCommand));
exports.AddCopyrightCommand = AddCopyrightCommand;
