"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var mime_1 = require("mime");
var operators_1 = require("rxjs/operators");
var json_1 = require("../utils/json");
var constants_1 = require("./../constants");
var rx_json_1 = require("./../utils/rx.json");
var rx_walk_1 = require("./../utils/rx.walk");
var abstract_command_1 = require("./abstract.command");
function _cleanupJSON(aFile) {
    aFile.data = json_1.canonicalizeJSON(aFile.data);
    return aFile;
}
var CanonicalizeAssetsCommand = /** @class */ (function (_super) {
    __extends(CanonicalizeAssetsCommand, _super);
    function CanonicalizeAssetsCommand(options) {
        return _super.call(this, options) || this;
    }
    CanonicalizeAssetsCommand.prototype.process = function () {
        // data dir
        var rxDataDir = this.rxMkdirp(this.getDataDir());
        // process
        return rxDataDir.pipe(operators_1.mergeMap(rx_walk_1.walkFiles), operators_1.filter(function (f) { return mime_1.getType(f.absPath) === 'application/json'; }), operators_1.mergeMap(rx_json_1.readJSON), operators_1.map(_cleanupJSON), operators_1.mergeMap(rx_json_1.writeJSON), operators_1.map(function (file) { return file.absPath; }));
    };
    CanonicalizeAssetsCommand.TYPE = 'assets';
    CanonicalizeAssetsCommand.COMMAND = constants_1.CMD_CANONICALIZE;
    return CanonicalizeAssetsCommand;
}(abstract_command_1.AbstractCommand));
exports.CanonicalizeAssetsCommand = CanonicalizeAssetsCommand;
