/// <reference types="handlebars" />
import { Observable, Subject } from 'rxjs';
import { ComponentClass, ComponentRegistry } from '../utils/component.reg';
import { Options } from './../options';
import { WchTools } from './../utils/wchtools';
import { AbstractCommand } from './abstract.command';
import { Command } from './command';
export interface Templates {
    abstractComponent: Observable<HandlebarsTemplateDelegate>;
    typeComponent: Observable<HandlebarsTemplateDelegate>;
    typeInterface: Observable<HandlebarsTemplateDelegate>;
    typeDefinition: Observable<HandlebarsTemplateDelegate>;
    typeHtml: Observable<HandlebarsTemplateDelegate>;
    typeCss: Observable<HandlebarsTemplateDelegate>;
    layoutModule: Observable<HandlebarsTemplateDelegate>;
    layoutComponent: Observable<HandlebarsTemplateDelegate>;
    layoutHtml: Observable<HandlebarsTemplateDelegate>;
    layoutCss: Observable<HandlebarsTemplateDelegate>;
    layoutOverview: Observable<HandlebarsTemplateDelegate>;
    layoutExports: Observable<HandlebarsTemplateDelegate>;
    moduleOverview: Observable<HandlebarsTemplateDelegate>;
    moduleExports: Observable<HandlebarsTemplateDelegate>;
}
declare function _createTemplate(aOptions: Options, aLogger: Subject<string>): Templates;
declare function _createAbstractComponentContext(aClass: ComponentClass, aComponentReg: ComponentRegistry, aTools: WchTools): Observable<any>;
declare function _createTypeInterfaceContext(aClass: ComponentClass, aComponentReg: ComponentRegistry, aTools: WchTools): Observable<any>;
declare function _createOverview(aSource: Observable<string>, aTemplate: Templates, aOptions: Options, aLogger: Subject<string>): Observable<string>;
declare function _rewriteAppModule(aLayoutExports: string, aModuleFile: string, aOptions: Options, aLogger: Subject<string>): Observable<string>;
/**
 * Generates angular components based on type and layout mapping definitions
 *
 * create components --data DATA_FOLDER --src SOURCE_CODE_FOLDER
 */
export declare class CreateComponentsCommand extends AbstractCommand implements Command {
    private options;
    static readonly TYPE: string;
    static readonly COMMAND: string;
    constructor(options: Options);
    printHelp(): void;
    process(): Observable<string>;
}
export { _createOverview as createComponentOverview, _createTemplate as createComponentTemplates, _rewriteAppModule as rewriteAppModule, _createAbstractComponentContext as createAbstractComponentContext, _createTypeInterfaceContext as createTypeInterfaceContext };
