"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var constants_1 = require("./../constants");
var wchtools_1 = require("./../utils/wchtools");
var abstract_command_1 = require("./abstract.command");
function _matches(aName, aMatcher, aLogger) {
    // check
    var result = aMatcher(aName);
    aLogger.next("Matching [" + aName + "] results in [" + result + "].");
    return result;
}
/**
 * Selects components by applying a matching function
 *
 * @param aMatcher  the matcher
 * @param aLogger   the logger
 */
function _byMatcher(aMatcher, aLogger) {
    // execute the check
    return function (aType) { return aType && aType.name && _matches(aType.name, aMatcher, aLogger); };
}
function _listTypes(aTools, aMatcher) {
    // filter the types
    return rxjs_1.of.apply(void 0, Object.keys(aTools.types)).pipe(operators_1.map(function (id) { return aTools.types[id]; }), operators_1.filter(aMatcher), operators_1.map(function (type) { return type.name; }));
}
var ShowTypesCommand = /** @class */ (function (_super) {
    __extends(ShowTypesCommand, _super);
    function ShowTypesCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    ShowTypesCommand.prototype.process = function () {
        var opts = this.options;
        // logger
        var logger = this.getLogger();
        // matcher
        var matcher = wchtools_1.wchToolsGetMatcher(opts);
        var typeMatcher = _byMatcher(matcher, logger);
        // tools
        var rxWchTools = this.getWchTools();
        // the types
        var rxTypes = rxWchTools.pipe(operators_1.mergeMap(function (aTools) { return _listTypes(aTools, typeMatcher); }));
        // ok
        return rxTypes;
    };
    ShowTypesCommand.TYPE = 'types';
    ShowTypesCommand.COMMAND = constants_1.CMD_SHOW;
    return ShowTypesCommand;
}(abstract_command_1.AbstractCommand));
exports.ShowTypesCommand = ShowTypesCommand;
