import { Observable, UnaryFunction } from 'rxjs';
import { FileDescriptor } from './rx.walk';
declare function _rxMkDirs(): UnaryFunction<string, Observable<string>>;
/**
 * Copies a set of source files to a destination directory
 *
 * @param aSources  the list of source files
 * @param aDst  the target directory
 *
 * @return the list of copied filed
 */
declare function _copyFiles(aSources: Observable<FileDescriptor>, aDst: string): Observable<string>;
declare const _rxCopyDir: (aSrc: string, aDst: string, aOverride?: boolean | undefined) => Observable<string>;
export { _rxCopyDir as rxCopyDir, _copyFiles as rxCopyFiles, _rxMkDirs as rxMkDirs };
