"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var tr = require('transliteration');
var slugifyCache = {};
function _slugify(aValue) {
    // check
    var cached = slugifyCache[aValue];
    if (!cached) {
        cached = slugifyCache[aValue] = tr.slugify(aValue);
    }
    // console.log('slugify', aValue, cached);
    return cached;
}
exports.slugify = _slugify;
var transliterateCache = {};
function _transliterate(aValue) {
    // check
    var cached = transliterateCache[aValue];
    if (!cached) {
        cached = transliterateCache[aValue] = tr.transliterate(aValue);
    }
    // console.log('transliterate', aValue, cached);
    return cached;
}
exports.transliterate = _transliterate;
var camelCaseCache = {};
function _camelCase(aValue) {
    // check
    var cached = camelCaseCache[aValue];
    if (!cached) {
        cached = camelCaseCache[aValue] = lodash_1.camelCase(_transliterate(aValue));
    }
    // console.log('camelCase', aValue, cached);
    return cached;
}
exports.camelCase = _camelCase;
var kebabCaseCache = {};
function _kebabCase(aValue) {
    // check
    var cached = kebabCaseCache[aValue];
    if (!cached) {
        cached = kebabCaseCache[aValue] = lodash_1.kebabCase(_transliterate(aValue));
    }
    // console.log('kebabCase', aValue, cached);
    return cached;
}
exports.kebabCase = _kebabCase;
