"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = require("typescript");
function _getDecoratorName(aDecorator) {
    var token = aDecorator.expression.getFirstToken();
    if (typescript_1.isIdentifier(token)) {
        return token.text;
    }
}
exports.tsGetDecoratorName = _getDecoratorName;
function _getDecorators(aNode) {
    var result = {};
    var decs = aNode.decorators;
    if (decs) {
        decs.forEach(function (dec) {
            if (typescript_1.isDecorator(dec)) {
                var key = _getDecoratorName(dec);
                if (key) {
                    result[key] = dec;
                }
            }
        });
    }
    return result;
}
exports.tsGetDecorators = _getDecorators;
