"use strict";
exports.__esModule = true;
var typescript_1 = require("typescript");
var change_1 = require("../ast-utils/change");
var ast_utils_1 = require("./../ast-utils/ast-utils");
var rx_file_1 = require("./rx.file");
var operators_1 = require("rxjs/operators");
function rxReadTypescriptFile(aPath) {
    // read
    return rx_file_1.rxReadTextFile(aPath).pipe(operators_1.map(function (src) { return ({
        source: src,
        path: aPath,
        ast: typescript_1.createSourceFile(aPath, src, typescript_1.ScriptTarget.Latest, true)
    }); }));
}
exports.rxReadTypescriptFile = rxReadTypescriptFile;
function _insertLeft(aPos, aChange, aTotal) {
    return aTotal.substr(0, aPos) + aChange + aTotal.substr(aPos);
}
function importModule(aName, aIdentifier, aFile) {
    var declarationChanges = ast_utils_1.addImportToModule(aFile.ast, aFile.path, aName, aIdentifier);
    var result = aFile.source;
    for (var _i = 0, declarationChanges_1 = declarationChanges; _i < declarationChanges_1.length; _i++) {
        var change = declarationChanges_1[_i];
        if (change instanceof change_1.InsertChange) {
            result = _insertLeft(change.pos, change.toAdd, result);
        }
    }
    return {
        path: aFile.path,
        source: result,
        ast: typescript_1.createSourceFile(aFile.path, result, typescript_1.ScriptTarget.Latest, true)
    };
}
exports.importModule = importModule;
