"use strict";
exports.__esModule = true;
/* Copyright IBM Corp. 2018 */
var graceful_fs_1 = require("graceful-fs");
var request = require("request");
var rxjs_1 = require("rxjs");
var random_ua = require('random-ua');
function _rxGetJson(aSrcUrl) {
    // the options
    var options = {
        url: aSrcUrl,
        headers: {
            'User-Agent': random_ua.generate(),
            'Accept': 'application/json'
        },
        json: true
    };
    // handle
    return rxjs_1.Observable.create(function (aObserver) {
        // assembled data
        var data = [];
        // read
        request(options, function (reqError, resp, data) {
            if (reqError) {
                aObserver.error(reqError);
            }
            else {
                aObserver.next(data);
                aObserver.complete();
            }
        });
    });
}
exports.rxGetJson = _rxGetJson;
function _rxDownloadFile(aSrcUrl, aDstFile) {
    // the options
    var options = {
        url: aSrcUrl,
        headers: {
            'User-Agent': random_ua.generate()
        }
    };
    // handle
    return rxjs_1.Observable.create(function (aObserver) {
        // read
        request(options)
            .on('error', function (reqError) { return aObserver.error(reqError); })
            .pipe(graceful_fs_1.createWriteStream(aDstFile))
            .on('error', function (unzipError) { return aObserver.error(unzipError); })
            .on('close', function () {
            aObserver.next(aDstFile);
            aObserver.complete();
        });
    });
}
exports.rxDownloadFile = _rxDownloadFile;
